"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useForceUpdate = void 0;
var react_1 = __importStar(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var useDidUpdate_1 = require("./useDidUpdate");
var batchUpdate = react_1.default['batchUpdate'] ||
    react_dom_1.default['batchUpdate'] ||
    react_dom_1.default['unstable_batchedUpdates'] ||
    (function (callback) { return callback(); });
var EMPTY_ARRAY = [];
var RENDER_COUNT = { value: 0 };
var RENDER_QUEUE = new Set();
function useForceUpdate() {
    var _a = __read(react_1.useState(0), 2), setTick = _a[1];
    var unmountRef = react_1.useRef(false);
    var update = react_1.useCallback(function () {
        if (RENDER_COUNT.value === 0) {
            if (unmountRef.current)
                return;
            batchUpdate(function () {
                setTick(function (tick) {
                    return tick + 1;
                });
            });
        }
        else {
            if (!RENDER_QUEUE.has(update)) {
                RENDER_QUEUE.add(update);
            }
        }
    }, EMPTY_ARRAY);
    RENDER_COUNT.value++;
    useDidUpdate_1.useDidUpdate(function () {
        RENDER_COUNT.value--;
        if (RENDER_COUNT.value === 0) {
            batchUpdate(function () {
                if (unmountRef.current)
                    return;
                RENDER_QUEUE.forEach(function (update) {
                    RENDER_QUEUE.delete(update);
                    update();
                });
            });
        }
    });
    react_1.useEffect(function () {
        unmountRef.current = false;
        return function () {
            unmountRef.current = true;
        };
    }, []);
    return update;
}
exports.useForceUpdate = useForceUpdate;
