"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.observer = void 0;
var react_1 = require("react");
var hoist_non_react_statics_1 = __importDefault(require("hoist-non-react-statics"));
var hooks_1 = require("./hooks");
function observer(baseComponent, options) {
    var realOptions = __assign({ forwardRef: false }, options);
    var wrappedComponent = function (props, ref) {
        return hooks_1.useObserver(function () { return baseComponent(props, ref); });
    };
    var memoComponent;
    if (realOptions.forwardRef) {
        memoComponent = react_1.memo(react_1.forwardRef(wrappedComponent));
    }
    else {
        memoComponent = react_1.memo(wrappedComponent);
    }
    hoist_non_react_statics_1.default(memoComponent, baseComponent);
    if (realOptions.displayName) {
        memoComponent.displayName = realOptions.displayName;
    }
    return memoComponent;
}
exports.observer = observer;
